#!/usr/bin/env python

# Copyright (C) 2011 Oracle. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, version 2.  This program is distributed in the hope that it will
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the GNU
# General Public License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 021110-1307, USA.

import optparse
import sys


def main(enumerator, targets):
    parser = optparse.OptionParser('%prog [option] <target>')
    parser.add_option('-e', '--enumerate', action='store_true',
                      help='enumerate parameters for target')
    (opts, args) = parser.parse_args()
    if len(args) != 1:
        parser.print_help(sys.stderr)
        sys.exit(1)
    target = args[0]
    if opts.enumerate:
        print enumerator(target)
        sys.exit(0)
    if target in targets:
        param = sys.stdin.read()
        try:
            print targets[target](param)
        except Exception, err:
            print >> sys.stderr, 'error calling target %s: %s' % (target, err)
            sys.exit(1)
    else:
        print >> sys.stderr, 'unknown target: %s' % target
        sys.exit(1)
